#include <string>
#include <iostream>
#include <fstream>
#include <cstring>

#include "cryptography.hpp"
#include "buffer.hpp"
#include "aes256.hpp"

Cryptography::Cryptography(std::string password)
{
	key = password;
}

Cryptography::~Cryptography()
{
}

void Cryptography::change_pass(std::string password)
{
	key = password;
}

bool Cryptography::encrypt(Buffer *plain, Buffer *encrypted)
{
	ByteArray in(plain->buffer, plain->buffer + plain->taken);
	ByteArray out;
	ByteArray key_b(key.begin(), key.end());
	Aes256::encrypt(key_b, in, out);
	encrypted->taken = 0;
	encrypted->add_end(out.data(), out.size());
	return true;
}

bool Cryptography::decrypt(Buffer *encrypted, Buffer *decrypted)
{
	ByteArray in(encrypted->buffer, encrypted->buffer + encrypted->taken);
	ByteArray out;
	ByteArray key_b(key.begin(), key.end());
	Aes256::decrypt(key_b, in, out);
	decrypted->taken = 0;
	decrypted->add_end(out.data(), out.size());
	return true;
}